<?php
  /**
   * Clase para Facturas Manuales.
   * @author calmaguer
   */

require_once('.\framework\classes\pdo.mysql.class.php');
require_once('.\framework\functions.php');


class factura_manual extends DBConnector
{
	public function xmlFactura($rfc_xml)
	{
		$id_factura = 1;
		
		//$r = array_shift($this->query($sql));
		$return = array();
		
		$empresa = array(
			'municipio' => "monterrey",
			'estado' => "nuevo leon",
			'rfc' => $rfc_xml,
			'razon_social' => "razon social",
			'telefonos' => "12457896 y 32659874",
			'fax' => "12457896 456",
		);
		$empresa = (object)$empresa;
		$cfd_schema = "cfdi";
                
                
                
		/*
		* Variables de prueba para generar timbrado correctamente
		*/
		$fecha_actual = date('Y-m-d')."T".date('H:i:s');
		$tipoComprobante = "ingreso"; // I = ingreso; E = Egreso; T = Traslado
		$pais = "mexico";
		
		
		//Informacion del receptor
		$calle_receptor = "calle";
		$num_ext_receptor = "0";
		$num_int_receptor = "0";
		$colonia_receptor = "Colonia";
		$localidad_receptor = "Localidad";
		$referencia_receptor = "0";
		$municipio_receptor = "Municipio";
		$estado_receptor = "Estado";
		$cp_receptor = "54321";
		$rfc_receptor = "AAA010101AAA";
		
		
		$serie = 'M';
		$folio = 1;
		$sello = '';
		$formaDePago = 'CONTADO';
		$noCertificado = '';
		$certificado = '';
		$subtotal = 1000.00;
		$total = 1160.00;
		$metodoDeDago = 'Contado';
		$LugarExpedicion = 'Monterrey, Nuevo Leon';
		
		$calle = 'calle siempre viva';
		$num_ext = '123';
		$num_int = 'n/a';
		$colonia = 'colonia';
		$municipio = 'municipio';
		$estado = 'estado';
		$cp = '12345';
		$referencia = '0';
		
		$tipo_regimen = 'COMERCIAL';
		$iva = 99.99;
                
                //====================================//
                //   Generacion de XML para Sellado   //
                //====================================//

                $domXML = new DOMDocument('1.0', 'UTF-8');
                $domXML->formatOutput = true;
                $root = $domXML->createElement('Comprobante');
                $root = $domXML->appendChild($root);
                //-- Atributos de Comprobante
                $this->addAttr($domXML, $root, 'version', '3.2');
                $this->addAttr($domXML, $root, 'serie', $serie);
                $this->addAttr($domXML, $root, 'folio', $folio);
                $this->addAttr($domXML, $root, 'fecha', $fecha_actual);

                //$this->addAttr($domXML, $root, 'rfc', $empresa->rfc);

                $this->addAttr($domXML, $root, 'sello', '');
                $this->addAttr($domXML, $root, 'formaDePago', 'CONTADO');
                $this->addAttr($domXML, $root, 'noCertificado', $noCertificado);
                $this->addAttr($domXML, $root, 'certificado', $certificado);
                $this->addAttr($domXML, $root, 'subTotal', $subtotal);
                $this->addAttr($domXML, $root, 'total', $total);
                $this->addAttr($domXML, $root, 'tipoDeComprobante', $tipoComprobante);
                $this->addAttr($domXML, $root, 'metodoDePago', $metodoDeDago);
                $this->addAttr($domXML, $root, 'LugarExpedicion', $LugarExpedicion);
                $this->addAttr($domXML, $root, 'xmlns', 'http://www.sat.gob.mx/cfd/3');
                $this->addAttr($domXML, $root, 'xmlns:xsi', 'http://www.w3.org/2001/XMLSchema-instance');
                $this->addAttr($domXML, $root, 'xsi:schemaLocation', 'http://www.sat.gob.mx/cfd/3 http://www.sat.gob.mx/sitio_internet/cfd/3/cfdv32.xsd' . $cfd_schema );

                //-- Atributos de Emisor
                $emisor = $domXML->createElement('Emisor');
                $root->appendChild($emisor);
                $this->addAttr($domXML, $emisor, 'rfc', $empresa->rfc);
                $this->addAttr($domXML, $emisor, 'nombre', $empresa->razon_social);

                //-- Domicilio Fiscal
                $dom_fiscal = $domXML->createElement('DomicilioFiscal');
                $emisor->appendChild($dom_fiscal);
                $this->addAttr($domXML, $dom_fiscal, 'calle', $calle);
                $this->addAttr($domXML, $dom_fiscal, 'noExterior', $num_ext);
                $this->addAttr($domXML, $dom_fiscal, 'noInterior', $num_int);
                $this->addAttr($domXML, $dom_fiscal, 'colonia', $colonia);
                $this->addAttr($domXML, $dom_fiscal, 'localidad', $municipio);
                $this->addAttr($domXML, $dom_fiscal, 'referencia', $referencia);
                $this->addAttr($domXML, $dom_fiscal, 'municipio', $municipio);
                $this->addAttr($domXML, $dom_fiscal, 'estado', $estado);
                $this->addAttr($domXML, $dom_fiscal, 'pais', $pais);
                $this->addAttr($domXML, $dom_fiscal, 'codigoPostal', $cp);

                //-- Datos de Expedicion
                $expedido = $domXML->createElement('ExpedidoEn');
                $emisor->appendChild($expedido);
                $this->addAttr($domXML, $expedido, 'calle', $calle);
                $this->addAttr($domXML, $expedido, 'noExterior', $num_ext);
                $this->addAttr($domXML, $expedido, 'noInterior', $num_int);
                $this->addAttr($domXML, $expedido, 'colonia', $colonia);
                $this->addAttr($domXML, $expedido, 'localidad', $municipio);
                $this->addAttr($domXML, $expedido, 'referencia', $referencia);
                $this->addAttr($domXML, $expedido, 'municipio', $municipio);
                $this->addAttr($domXML, $expedido, 'estado', $estado);
                $this->addAttr($domXML, $expedido, 'pais', $pais);
                $this->addAttr($domXML, $expedido, 'codigoPostal', $cp);

                //-- Datos de Regimen Fiscal
                $regimen = $domXML->createElement('RegimenFiscal');
                $emisor->appendChild($regimen);
                $this->addAttr($domXML, $regimen, 'Regimen', $tipo_regimen);

                //-- Datos del Receptor
                $receptor = $domXML->createElement('Receptor');
                $root->appendChild($receptor);
                $this->addAttr($domXML, $receptor, 'rfc', $rfc_receptor);
//				$this->addAttr($domXML, $receptor, 'nombre', $r['receptor_razon_social']);

                //-- Datos del Domicilio del Receptor
                $domicilio = $domXML->createElement('Domicilio');
                $receptor->appendChild($domicilio);
                $this->addAttr($domXML, $domicilio, 'calle', $calle_receptor);
                $this->addAttr($domXML, $domicilio, 'noExterior', $num_ext_receptor);
                $this->addAttr($domXML, $domicilio, 'noInterior', $num_int_receptor);
                $this->addAttr($domXML, $domicilio, 'colonia', $colonia_receptor);
                $this->addAttr($domXML, $domicilio, 'localidad', $localidad_receptor);
                $this->addAttr($domXML, $domicilio, 'referencia', $referencia_receptor);
                $this->addAttr($domXML, $domicilio, 'municipio', $municipio_receptor);
                $this->addAttr($domXML, $domicilio, 'estado', $estado_receptor);
                $this->addAttr($domXML, $domicilio, 'pais', $pais);
                $this->addAttr($domXML, $domicilio, 'codigoPostal', $cp_receptor);

                //-- Conceptos de la Factura
                $conceptos = $domXML->createElement('Conceptos');
                $root->appendChild($conceptos);


                $rowsConceptos = $this->conceptosFactura($id_factura);

                foreach ($rowsConceptos AS $item) {
                        $concepto = $domXML->createElement('Concepto');
                        $conceptos->appendChild($concepto);

                        $this->addAttr($domXML, $concepto, 'cantidad', $item['cantidad']);
                        $this->addAttr($domXML, $concepto, 'unidad', $item['unidad']);
                        $this->addAttr($domXML, $concepto, 'descripcion', $item['descripcion']);
                        $this->addAttr($domXML, $concepto, 'valorUnitario', $item['valor_unitario']);
                        $this->addAttr($domXML, $concepto, 'importe', $item['importe']);
//					Nodo InformacionAduanera
                }

                //-- Datos de los Impuestos
                if ($iva > 0) {
                        $impuestos = $domXML->createElement('Impuestos');
                        $root->appendChild($impuestos);
                        $retenciones = $domXML->createElement('Retenciones');
                        $impuestos->appendChild($retenciones);
                        $retencion = $domXML->createElement('Retencion');
                        $retenciones->appendChild($retencion);
                        $this->addAttr($domXML, $retencion, 'impuesto', 'IVA');
                        $this->addAttr($domXML, $retencion, 'importe', '0');
                        /*
                        $traslados = $domXML->createElement('traslados');
                        $impuestos->appendChild($traslados);
                        $traslado = $domXML->createElement('Traslado');
                        $traslados->appendChild($traslado);
                        $this->addAttr($domXML, $traslado, 'impuesto', 'IVA');
                        $this->addAttr($domXML, $traslado, 'tasa', '0');
                        $this->addAttr($domXML, $traslado, 'importe', '0');
                         * 
                         */
                }

                        $return[] = array(
                                'id_factura' => $id_factura,
                                'fecha_sellado' => '2013-11-14 16:58:00',//date('Y-m-d H:i:s'),
                                'xml' => $domXML->save("archivo.xml")
                        );
				
		return $return;
	}

	public function conceptosFactura($id_factura, $dataset = 'dsConceptosFactura'){
            $db_connection = new DBConnector(1, 'localhost', '3306', 'root', '', 'cfdi');
		$sql = "
			SELECT fc.*, tuf.descripcion AS unidad
			FROM factura_manual_conceptos AS fc
			LEFT OUTER JOIN tipos_unidades_facturas AS tuf
				ON tuf.id_unidad = fc.id_unidad
			WHERE id_factura = ". $id_factura;
                $result = $db_connection->query($sql);
		return $result;
	}


	private function addAttr(&$domXML, &$obj, $attr, $val)
	{
		$attrNode = $domXML->createAttribute($attr);
		$obj->appendChild($attrNode);

		if ($val != '') {
			$txtNode = $domXML->createTextNode(utf8_encode($val));
			$attrNode->appendChild($txtNode);
		}
	}
}
?>