/*===================================================================================================*/
/*   Helper de JavaScript para apoyar la construccion y control de algunos elementos del template.   */
/*===================================================================================================*/

$(document).ready(
	function () {
		moment.lang('es', {
			months : "Enero_Febrero_Marzo_Abril_Mayo_Junio_Julio_Agosto_Septiembre_Octubre_Noviembre_Diciembre".split("_"),
			monthsShort : "Ene_Feb_Mar_Abr_May_Jun_Jul_Ago_Sep_Oct_Nov_Dic".split("_"),
			weekdays : "Domingo_Lunes_Martes_Miércoles_Jueves_Viernes_Sábado".split("_"),
			weekdaysShort : "Dom_Lun_Mar_Mie_Jue_Vie_Sab".split("_"),
			longDateFormat : {
				L : "DD/MM/YYYY",
				LL : "D MMMM YYYY",
				LLL : "D MMMM YYYY HH:mm",
				LLLL : "dddd, D MMMM YYYY HH:mm"
			},
			meridiem : {
				AM : 'AM',
				am : 'am',
				PM : 'PM',
				pm : 'pm'
			}
		});
		moment.lang('es');
	}
);

String.prototype.repeat = function(l) {
	return new Array(l+1).join(this);
};

String.prototype.trim = function() {
	return this.replace(/^\s+|\s+$/g, '');
};

String.prototype.right = function(n) {
	return this.substr(this.length - n, n);
};

Array.prototype.search = function(v) {
	var z;
	pos = -1;

	for (z = 0; z < this.length; z++) {
		if (this[z] == v) {
			pos = z;
			break;
		}
	}

	return pos;
};

//-- Implementación de Array.indexOf() para Internet Explorer
if (! Array.indexOf) {
	Array.prototype.indexOf = function(obj) {
		for (var i = 0; i < this.length; i++) {
			if (this[i] == obj) return i;
		}
		
		return -1;
	}
}

String.prototype.pad = function(l, s, t)
{
    return s || (s = " "), (l -= this.length) > 0 ? (s = new Array(Math.ceil(l / s.length)
        + 1).join(s)).substr(0, t = !t ? l : t == 1 ? 0 : Math.ceil(l / 2))
        + this + s.substr(0, l - t) : this;
}


String.prototype.reverse = function()
{
    splitext = this.split('');
    revertext = splitext.reverse();
    reversed = revertext.join('');
    return reversed;
}

/**
 * Determina si la fecha indicada es válida en formato dd/mm/aaaa.
 * @calmaguer
 */
function fechaValida(fecha)
{
	//-- Expresión regular para separar fecha
	_regexp = /^\d{2}[-|\/]\d{2}[-|\/]\d{4}$/

	//-- Fecha es válida?
	_valida = false;

	//-- Elimina delimitadores de fecha
	_temp = fecha.replace(/-|\.|\//g, '')

	//-- Verificacion de formato (dd/mm/aaaa)
	if (_regexp.test(fecha)) {
		//-- Separa componentes de la fecha
		_aFecha = _temp.match(/(\d{2})(\d{2})(\d{4})/);

		_day = parseFloat(_aFecha[1]);
		_month = parseFloat(_aFecha[2]) - 1;
		_year = parseFloat(_aFecha[3]);

		//-- Crea un objeto date con los componentes enviados
		_newDate = new Date(_year, _month, _day);

		// Verifica si coinciden componentes de fecha generada y fecha enviada
		if (_year ==  _newDate.getFullYear()
				&& _month ==  _newDate.getMonth()
				&& _day ==  _newDate.getDate()) {
			_valida = true;
		}
	}

	return (_valida);
}

/*
 * Funcion para cargar dinamicamente un archivo JavaScript al documento actual
 */
function loadJSFile(js_url,mode)
{
                if(mode == 'undefined'){mode= true}
                $.ajax({
                               type : 'GET',
                               cache : false,
                               url : js_url,
                               dataType : 'script',
                               async : mode
                });
}

/**
 * Funcion que calcula la edad en base a una fecha en formato dd/mm/aaaa
 */
function calcAge(date) {
	var now = new Date();
	var aDate = date.split('/');
	var birthDate = new Date(aDate[2], aDate[1] - 1, aDate[0]);

	function isLeap(year) {
		return year % 4 == 0 && (year % 100 != 0 || year % 400 == 0);
	}

	var days = Math.floor((now.getTime() - birthDate.getTime()) / 1000 / 60 / 60 / 24);
	var age = 0;

	for (var y = birthDate.getFullYear(); y <= now.getFullYear(); y++){
		var daysInYear = isLeap(y) ? 366 : 365;
		
		if (days >= daysInYear){
			days -= daysInYear;
			age++;
		}
	}

	return age;
}

function roundNumber(num, dec) {
	var result = Math.round(num * Math.pow(10, dec)) / Math.pow(10, dec);
	return result;
}