<?php

require_once('./lib/nusoap/nusoap.php');
require_once "servisim/class.ConectorServisim.php";
require_once('./functions/functions.php');
require('framework/classes/pdo.mysql.class.php');
require_once './qrlib/qrlib.php';

define(OPENSSL, "c:/openssl-win32/bin/openssl");
define(TEMP, str_replace('\\', '/', $_SERVER['DOCUMENT_ROOT']) .
		preg_replace('/(\/.*\/).*/', '$1', $_SERVER['PHP_SELF']) . "temp/");

if (!is_dir(TEMP)) {
	mkdir(TEMP);
}

$server = new soap_server();
$ns = "http://cfdicore";

/* ------------------------------------------------------------------------------------------------ */
/* --                  Configuracion para Generaci�n de Descripci�n del Servicio                 -- */
/* ------------------------------------------------------------------------------------------------ */
//$server->configureWSDL('registerEmisor', $ns, FALSE, 'rpc');
$server->configureWSDL('SoftnetCFDi', $ns, FALSE, 'rpc');
$server->wsdl->schemaTargetNamespace = $ns;

//-- Solicitamos que no se haga la decodificacion UTF-8
//$server->soap_defencoding = 'UTF-8';
$server->decode_utf8 = false;

//-- Declaración de tipo de datos para la entrada
//REGITRO DE EMISOR
$server->wsdl->addComplexType(
		"emisorRequest", "complexType", "struct", "all", "", array(
	"rfc" => array("name" => "rfc", "type" => "xsd:string"),
	"certificado" => array("name" => "certificado", "type" => "xsd:string"),
	"llave" => array("name" => "llave", "type" => "xsd:string"),
	"contrasenia" => array("name" => "contrasenia", "type" => "xsd:string")
		)
);

//GENERACION TIMBRADO CFDI
$server->wsdl->addComplexType(
		"timbradoCFDiRequest", "complexType", "struct", "all", "", array(
	"rfc" => array("name" => "rfc", "type" => "xsd:string"),
	"xml" => array("name" => "xml", "type" => "xsd:string")
		)
);

//CANCELACION TIMBRADO CFDI
$server->wsdl->addComplexType(
		"cancelacionCFDiRequest", "complexType", "struct", "all", "", array(
	"rfc" => array("name" => "rfc", "type" => "xsd:string"),
	"uuid" => array("name" => "uuid", "type" => "xsd:string")
		)
);


//-- Declaraci�n de tipo de datos para la salida
//REGITRO DE EMISOR
$server->wsdl->addComplexType(
		"emisorResponse", "complexType", "struct", "all", "", array(
	"result" => array("name" => "result", "type" => "xsd:string"),
	"message" => array("name" => "message", "type" => "xsd:string"),
	"numero_serie" => array("name" => "numero_serie", "type" => "xsd:string"),
	"vigencia_desde" => array("name" => "vigencia_desde", "type" => "xsd:string"),
	"vigencia_hasta" => array("name" => "vigencia_hasta", "type" => "xsd:string")
		)
);

//GENERACION TIMBRADO CFDI
$server->wsdl->addComplexType(
		"timbradoCFDiResponse", "complexType", "struct", "all", "", array(
	"result" => array("name" => "result", "type" => "xsd:string"),
	"message" => array("name" => "message", "type" => "xsd:string"),
	"fecha_timbrado" => array("name" => "fecha_timbrado", "type" => "xsd:string"),
	"uuid" => array("name" => "uuid", "type" => "xsd:string"),
	"cadena_timbre" => array("name" => "cadena_timbre", "type" => "xsd:string"),
	"qrcode" => array("name" => "qrcode", "type" => "xsd:string"),
	"xml" => array("name" => "xml", "type" => "xsd:string")
		)
);

//CANCELACION TIMBRADO CFDI
$server->wsdl->addComplexType(
		"cancelacionCFDiResponse", "complexType", "struct", "all", "", array(
	"result" => array("name" => "result", "type" => "xsd:string"),
	"message" => array("name" => "message", "type" => "xsd:string")
		)
);



/* ------------------------------------------------------------------------------------------------ */
/* --                          Registro de M�todos p�blicos del Servicio                         -- */
/* ------------------------------------------------------------------------------------------------ */
//REGITRO DE EMISOR
$server->register(
		"registerEmisor", 
		array("in" => "tns:emisorRequest"), 
		array("out" => "tns:emisorResponse"), 
		$ns, FALSE, "rpc", "literal", "", "http://schemas.xmlsoap.org/soap/encoding/"
);

//GENERACION TIMBRADO CFDI
$server->register(
		"timbradoCFDi", 
		array("in" => "tns:timbradoCFDiRequest"), 
		array("out" => "tns:timbradoCFDiResponse"), 
		$ns, FALSE, "rpc", "literal", "", "http://schemas.xmlsoap.org/soap/encoding/"
);

//CANCELACION TIMBRADO CFDI
$server->register(
		"cancelacionCFDi", array("in" => "tns:cancelacionCFDiRequest"), array("out" => "tns:cancelacionCFDiResponse"), $ns, FALSE, "rpc", "literal", "", "http://schemas.xmlsoap.org/soap/encoding/"
);


/* ------------------------------------------------------------------------------------------------ */
/* --                          Activaci�n de Listener para el Servicio                           -- */
/* ------------------------------------------------------------------------------------------------ */
if (isset($HTTP_RAW_POST_DATA)) {
	$input = $HTTP_RAW_POST_DATA;
} else {
	$input = implode("\r\n", file('php://input'));
}

$server->service($input);

/* ------------------------------------------------------------------------------------------------ */
/* --                       Implementacion de M�todos PUBLICOS del Servicio                      -- */
/* ------------------------------------------------------------------------------------------------ */

function cancelacionCFDi($params) {
	$rfc = $params['rfc'];
	$uuid = $params['uuid'];
	$error = TRUE;
	$result = array(
		'result' => TRUE,
		'message' => ''
	);
	
	//Se verifica que exista un uuid generado.
	$res = existUuid($uuid);
	$exist = $res['exist'];
	$cancel = $res['cancelado'];
	if ($exist) {
		if (!$cancel) {
			//Envio la cancelacion a Servisim
			$result = cancelaTimbrado($rfc, $uuid);
			//Si la respuesta es ok, elimino de la base de datos.
			if (empty($result['id_error'])) {
				cancelaTimbradoCFDi($uuid);
				$message = "El CFDi ha sido cancelado correctamente";
				$error = FALSE;
			} else {
				$message = $result['message'];
			}
		} else {
			$message = "El CFDi ya estaba previamente cancelado";
		}
	} else {
		$message = "No existe el timbrado.";
	}

	$rs['result'] = $error;
	$rs['message'] = $message;
	return new soapval('out', 'SOAP-ENC:Array', $rs);
}

function registerEmisor($params) {

	$result = array(
		'result' => TRUE,
		'message' => '',
		'numero_serie' => '',
		'vigencia_desde' => '',
		'vigencia_hasta' => ''
	);
	$error = TRUE;
	
	$certificado = base64_decode(utf8_decode($params['certificado']));
	$llave = base64_decode(utf8_decode($params['llave']));
	$password = $params['contrasenia'];
	$rfc = $params['rfc'];
	
	$rs_certificado = validateCertificado($certificado, $llave, $password, $rfc);
	
	//Si el mensaje es diferente a 1 entonces ocurrio un error
	if ($rs_certificado['valid'] != '1') {
		$message = "ERROR: " . $rs_certificado['message'];
	} else {
		$rs = newEmisor($rfc, $certificado, $llave, $password);
		if (empty($rs['result'])) {
			saveEmisor($rs_certificado);
			$message = utf8_decode($rs['message']);
			$error = FALSE;
			$numero_serie = $rs_certificado['noCertificado'];
			$vigencia_desde = $rs_certificado['vigencia_desde'];
			$vigencia_hasta = $rs_certificado['vigencia_hasta'];
		} else {
			$message = utf8_decode($rs['message']);
		}
	}
	
	
	$result['result'] = $error;
	$result['message'] = $message;
	$result['numero_serie'] = $numero_serie;
	$result['vigencia_desde'] = $vigencia_desde;
	$result['vigencia_hasta'] = $vigencia_hasta;
	return new soapval('out', 'SOAP-ENC:Array', $result);
}

function timbradoCFDi($params) {
	$rfc = $params['rfc'];
	$xml = $params['xml'];
	$uuid = "0";
	$qrcode = "";
	$error = TRUE;
	
	$result = array(
		'result' => TRUE,
		'message' => '',
		'fecha_timbrado' => '',
		'uuid' => '',
		'cadena_timbre' => '',
		'qrcode' => '',
		'xml' => ''
	);
	
	$certificado = getCertificado($rfc);

	//Se verifica que exista como emisor.
	if ($certificado['exist_emisor']) {

		//Se verifica que el certificado sea valido.
		if ($certificado['valid']) {
			//Se realiza el sellado de la factura.
			$sellado = sellarFactura($xml, $certificado);
	
			//Se verifica que el sellado se haya realizado correctamente.
			if ($sellado['sellado'] == TRUE) {
				//Se asigna un id de respuesta.
				$id_factura = 'FAC-001';
				//Se obtiene el timbrado para la factura
				$stamp = getStamp($id_factura, $sellado['xml']);
//				$stamp = getStamp($id_factura, utf8_encode($sellado['xml']));

				if (empty($stamp['id_error'])) {

					$uuid = $stamp['uuid'];
					$fecha_timbrado = $stamp['fecha'];
					$xml = $stamp['xml'];
					
					$cadena_timbre = getCadenaTimbre($uuid, $fecha_timbrado, $sellado);
					
					//Se obtiene el QR Code.
					$qrc = getQR($xml, $uuid);
					$qrcode = $qrc['code'];
					$total = $qrc['total'];

					$sello = $sellado['sello'];
					//Se guarda toda la informacion del timbrado en la base de datos.
					saveStamp($id_factura, $rfc, $sello, $uuid, $fecha_timbrado, $qrcode, $xml);
					$error = FALSE;
					$message = "Timbrado realizado con exito.";
				} else {
					$message = $stamp['error'];
				}
			} else {
				$message = $sellado['message'];
			}
		} else {
			$message = $certificado['message'];
		}
	} else {
		$message = $certificado['message'];
	}
	
	$result['result'] = $error;
	$result['message'] = $message;
	$result['fecha_timbrado'] = $fecha_timbrado;
	$result['uuid'] = $uuid;
	$result['cadena_timbre'] = $cadena_timbre;
	$result['qrcode'] = $qrcode;
	$result['total'] = $total;
	$result['xml'] = utf8_decode($xml);
	return new soapval('out', 'SOAP-ENC:Array', $result);
}

function saveEmisor($rs_certificado) {

	//* Conexion para obtener el certificado mediante el rfc.
	$db_connection = new DBConnector(1, 'localhost', '3306', 'root', '', 'cfdi');
	//Se agrega la informacion del emisor y su certificado.
	$variables = array();
	$variables['sNombre'] = $rs_certificado['titular'];
	$variables['sRfc'] = $rs_certificado['rfc'];
	$variables['sNumCertificado'] = $rs_certificado['noCertificado'];
	$variables['bCertificado'] = $rs_certificado['certificado'];
	$variables['bLlave_der'] = $rs_certificado['llave_key'];
	$variables['bLlave_pem'] = $rs_certificado['llave_pem'];
	$variables['sPass'] = $rs_certificado['password'];
	$variables['dVigencia_desde'] = $rs_certificado['vigencia_desde'];
	$variables['dVigencia_hasta'] = $rs_certificado['vigencia_hasta'];

	$sp = "altaEmisor(:sNombre, :sRfc, :sNumCertificado, :bCertificado, :bLlave_der, :bLlave_pem, :sPass, :dVigencia_desde, :dVigencia_hasta)";
	$rs = $db_connection->executeSP($sp, $variables);

	return TRUE;
}

function saveStamp($id_factura, $rfc, $sello, $uuid, $fecha_timbrado, $qrcode, $xml) {
	//* Conexion para obtener el certificado mediante el rfc.
	$db_connection = new DBConnector(1, 'localhost', '3306', 'root', '', 'cfdi');
	//Se agrega la informacion del emisor y su certificado.
	$variables = array();
	$variables['sIdFactura'] = $id_factura;
	$variables['sRfc'] = $rfc;
	$variables['bSello'] = $sello;
	$variables['sUuid'] = $uuid;
	$variables['dFechaTimbre'] = $fecha_timbrado;
	$variables['bQrcode'] = $qrcode;
	$variables['tXml'] = utf8_decode($xml);

	$sp = "registroTimbrado(:sIdFactura, :sRfc, :bSello, :sUuid, :dFechaTimbre, :bQrcode, :tXml)";
	$rs = $db_connection->executeSP($sp, $variables);

	return TRUE;
}


function getQR($xml, $uuid) {
	$doc_xml = new DOMDocument();
	$doc_xml->formatOutput = true;
	$doc_xml->loadXML(utf8_encode($xml));

	$comprobante = $doc_xml->getElementsByTagName('Comprobante')->item(0);
	$emisor = $comprobante->getElementsByTagName('Emisor')->item(0);
	$rfc_emisor = '?re=' . $emisor->getAttribute('rfc');
	$receptor = $comprobante->getElementsByTagName('Receptor')->item(0);
	$rfc_receptor = '&rr=' . $receptor->getAttribute('rfc');
		
	$total = floatVal($comprobante->getAttribute('total'));
	$digitos = explode('.',$total);
	$enteros = str_pad(trim($digitos[0]), 10, '0', STR_PAD_LEFT);
	$decimales = str_pad(trim($digitos[1]), 6, '0', STR_PAD_RIGHT);
	
	$total = '&tt=' . $enteros.".".$decimales;
	$uuid = '&id=' . $uuid;
	$texto = $rfc_emisor . $rfc_receptor . $total . $uuid;
	$_tmpQR = './temp/QR_' . rand() . '.png';
	QRcode::png($texto, $_tmpQR, QR_ECLEVEL_H, 5, 0);
	
	$qr = file_get_contents($_tmpQR);
	$code['code'] = base64_encode($qr);
	unlink($_tmpQR);
	return $code;
}

function getCadenaTimbre($uuid, $fecha_timbrado, $sellado) {
	return "||1.0|" . $uuid . "|" . $fecha_timbrado . "|" . $sellado['sello'] . "|" . $sellado['num_certificado'];
}

function newEmisor($rfc, $certificado, $llave, $password) {
	$db_connection = new DBConnector(1, 'localhost', '3306', 'root', '', 'cfdi');
	$config['nType'] = 1;
	$rs = $db_connection->executeSP('getConfigWebService(:nType)', $config);
	$token_conf = $rs[0]['token'];
	$user_conf = $rs[0]['user'];
	$pass_conf = $rs[0]['passw'];
	$endpoint = $rs[0]['endpoint'];
	$url = (empty($rs[0]['url']) || $rs[0]['url'] == '') ? 'http://controller.timbrado.ws.servisim.com/' : $rs[0]['url'];

	//1. Creamos nuevo objeto de conexión.
	$conector = new ConectorServisim();
	//1.1 Establecemos EndPoint de Servisim. (Sin ?wsdl al final)
	$conector->establecerEndPoint($endpoint);
	//1.2 Establecemos la acción a realizar.
	$conector->establecerSoapAction($url, 'registrarEmisor');
	//1.3 Establecemos los datos de acceso al servicio web.
	$conector->establecerAcceso($user_conf, $pass_conf);
	//2. Crear petición
	$conector->crearPeticion();
	//3. Asignamos datos a la petición.
	$conector->asignarEnPeticion('Certificado', $certificado);
	$conector->asignarEnPeticion('Llave', $llave);
	$conector->asignarEnPeticion('Password', $password);
	$conector->asignarEnPeticion('Rfc', $rfc);
	$conector->asignarEnPeticion('Token', $token_conf);
	//4. consumir servicio
	$conector->consumirServicio();
	$result['result'] = $conector->obtenerDeRespuesta('IdError');
	$result['message'] = $conector->obtenerDeRespuesta('Resultado');
	return $result;
}

function getStamp($id_request, $file_xml) {
	$db_connection = new DBConnector(1, 'localhost', '3306', 'root', '', 'cfdi');
	$config['nType'] = 2;
	$rs = $db_connection->executeSP('getConfigWebService(:nType)', $config);
	$user_conf = $rs[0]['user'];
	$pass_conf = $rs[0]['passw'];
	$endpoint = $rs[0]['endpoint'];
	$url = (empty($rs[0]['url']) || $rs[0]['url'] == '') ? 'http://controller.timbrado.ws.servisim.com/' : $rs[0]['url'];

	//1. Creamos nuevo objeto de conexión.
	$conector = new ConectorServisim();
	//1.1 Establecemos EndPoint de Servisim. (Sin ?wsdl al final)
	$conector->establecerEndPoint($endpoint);
	//1.2 Establecemos la acción a realizar.
	$conector->establecerSoapAction($url, 'timbrarCFDi');
	//1.3 Establecemos los datos de acceso al servicio web.
	$conector->establecerAcceso($user_conf, $pass_conf);
	//2. Crear petición
	$conector->crearPeticion();
	//3. Asignamos datos a la petición.
	//3.1 Asignamos Identificador UNICO del CFDi. ejemplo: SERIE+FOLIO
	$conector->asignarEnPeticion('Id', $id_request);
	//3.2 Asignamos el Contenido del XML ya sellado por el Emisor.
	$conector->asignarEnPeticion('Xml', $file_xml);
	//4. consumir servicio
	$conector->consumirServicio();
	//$resp = $conector->obtenerDeRespuesta('Xml');
	//Se guarda la respuesta en el archivo XML
	//file_put_contents('archivo1.xml', $resp);
	$stamp['uuid'] = $conector->obtenerDeRespuesta('Uuid');
	$stamp['id_error'] = $conector->obtenerDeRespuesta('IdError');
	$stamp['error'] = $conector->obtenerDeRespuesta('Error');
	$stamp['fecha'] = $conector->obtenerDeRespuesta('FechaTimbre');
	$stamp['xml'] = $conector->obtenerDeRespuesta('Xml');
	return $stamp;
}

function sellarFactura($xml, $certificado) {

	$oCFDI = new DOMDocument("1.0", "UTF-8");
	$oCFDI->formatOutput = true;
	
	if ($oCFDI->loadXML($xml)) {
		// $oCFDI->loadXML($xml);
		$root = $oCFDI->documentElement;
		$base64cert = preg_replace('/\n$/', '', chunk_split(base64_encode($certificado['certificado']), 64, LF));
		$root->setAttribute('certificado', $base64cert);
		$root->setAttribute('noCertificado', $certificado['noCertificado']);

		//-- Generacion de cadena original y sellado del CFD
		$cadena = generarCadena($root);
		
		$sello = selloDigital($cadena, $certificado['llave_pem'], $certificado['password']);
		$root->setAttribute('sello', $sello);
		
		$result['sellado'] = TRUE;
		$result['sello'] = $sello;
		$result['num_certificado'] = $certificado['noCertificado'];
		$result['xml'] = $oCFDI->saveXML();
	} else {
		$result['sellado'] = FALSE;
		$result['message'] = 'No se recibio un documento XML valido para un comprobante fiscal digital.';
	}
	return $result;
}

function selloDigital($cadena, $privKey, $pass) {
	$_sello = FALSE;
	if ($_rsKey = openssl_pkey_get_private($privKey, $pass)) {
		$keyFile = TEMP . 'priv_key.pem';
		file_put_contents($keyFile, $privKey);

		$strFile = TEMP . 'cadena.tmp';
		file_put_contents($strFile, $cadena);

		$cmd = OPENSSL . ' dgst -sha1 -sign "' . $keyFile . '" -keyform PEM "' . $strFile . '"';
		@exec($cmd, $_firma, $result);

		$_sello = base64_encode(implode("\n", $_firma));
	}
	return $_sello;
}

function getCertificado($rfc) {
	// * Conexion para obtener el certificado mediante el rfc.
	$db_connection = new DBConnector(1, 'localhost', '3306', 'root', '', 'cfdi');
	//$db_connection = DBConnect();
	$rs = $db_connection->executeSP('obtenerCertificado(:sRfc)', array('sRfc' => $rfc));
	$rs = $rs[0];


	//Se verifica que el emisor este registrado.
	if ($rs['exist_emisor']) {
		//Se valida el certificado.
		$cert = validateCertificado($rs['certificado'], $rs['llave_der'], $rs['pass'], $rs['rfc']);
		if ($cert['valid'] == FALSE) {
			$cert['res'] = '0';
			$cert['message'] = "ERROR: " . $cert['message'];
		}
		$cert['exist_emisor'] = TRUE;
	} else {
		$cert['exist_emisor'] = FALSE;
		$cert['message'] = "El emisor no se encuentra registrado.";
	}

	return $cert;
}

function existUuid($uuid) {
	// * Conexion para obtener el certificado mediante el rfc.
	$db_connection = new DBConnector(1, 'localhost', '3306', 'root', '', 'cfdi');
	//$db_connection = DBConnect();
	$rs = $db_connection->executeSP('existTimbrado(:sUuid)', array('sUuid' => $uuid));
	$exist = $rs[0];
	return $exist;
}

function cancelaTimbradoCFDi($uuid) {
	// * Conexion para obtener el certificado mediante el rfc.
	$db_connection = new DBConnector(1, 'localhost', '3306', 'root', '', 'cfdi');
	//$db_connection = DBConnect();
	$rs = $db_connection->executeSP('cancelaTimbrado(:sUuid)', array('Uuid' => $uuid));
	return TRUE;
}

function cancelaTimbrado($rfc, $uuid) {
	$db_connection = new DBConnector(1, 'localhost', '3306', 'root', '', 'cfdi');
	$config['nType'] = 3;
	$rs = $db_connection->executeSP('getConfigWebService(:nType)', $config);
	$user_conf = $rs[0]['user'];
	$pass_conf = $rs[0]['passw'];
	$endpoint = $rs[0]['endpoint'];
	$url = (empty($rs[0]['url']) || $rs[0]['url'] == '') ? 'http://controller.timbrado.ws.servisim.com/' : $rs[0]['url'];


	//1. Creamos nuevo objeto de conexión.
	$conector = new ConectorServisim();
	$conector->establecerEndPoint($endpoint);
	//1.2 Establecemos la acción a realizar.
	$conector->establecerSoapAction($url, 'cancelarCFDi');
	//1.3 Establecemos los datos de acceso al servicio web.
	$conector->establecerAcceso($user_conf, $pass_conf);
	//2. Crear petición
	$conector->crearPeticion();
	//3. Asignamos datos a la petición.

	$conector->asignarEnPeticion('Id', $rfc);
	$conector->asignarEnPeticion('Xml', $uuid);

	//4. consumir servicio
	$conector->consumirServicio();

	$cancelacion['id_error'] = $conector->obtenerDeRespuesta('IdError');
	$cancelacion['message'] = $conector->obtenerDeRespuesta('Error');

	return $cancelacion;
}

function validateCertificado($certificado, $llave_privada, $password, $rfc) {
	$result = array();

	//Se verifica si es un certificado valido.
	if (@openssl_x509_read(DER2PEM($certificado))) {

		//-- Crea archivo de llave DER temporal
		$keyFile = TEMP . 'temp_private_key.key';
		file_put_contents($keyFile, $llave_privada);
		//-- Conversion con OpenSSL de llave privada DER a PEM temporal
		$pemFile = TEMP . 'temp_' . $rand . '.pem';
		$cmdOpenSSL = OPENSSL . ' pkcs8 -inform DER'
				. ' -in "' . $keyFile . '"'
				. ' -passin pass:' . $password
				. ' -out "' . $pemFile . '"';
		@exec($cmdOpenSSL);

		//-- Verifica valides de Llave Privada y/o contrase?a
		$pemKey = file_get_contents($pemFile);

		if (strlen($pemKey) > 0 && strpos($pemKey, 'PRIVATE KEY') !== FALSE) {
			//-- Llave privada y contrase?a v?lidas! Llave PEM generada correctamente
			//-- Verifica llave privada contra el certificado!
			if (openssl_x509_check_private_key(DER2PEM($certificado), $pemKey)) {
				//Se obtiene la informacion del certificado.
				$parsed = openssl_x509_parse(DER2PEM($certificado), FALSE);
				$now = time();
				$rfc_cert = explode('/', $parsed['subject']['x500UniqueIdentifier']);
				$rfc_cert = trim($rfc_cert[0]);
				//Se comprueba que el RFC ingresado corresponda al RFC del certificado.
				if ($rfc == $rfc_cert) {
					//Se valida que el certificado este vigente
					if ($parsed['validTo_time_t'] < $now) {
						$result['message'] = 'Certificado vencido.';
					} else {
						$rfc_cert = explode('/', $parsed['subject']['x500UniqueIdentifier']);
						$result['llave_pem'] = $pemKey;
						$result['noCertificado'] = decodeSerialNumber($parsed['serialNumber']);
						;
						$result['llave_key'] = $llave_privada;
						$result['titular'] = $parsed['subject']['commonName'];
						;
						$result['vigencia_desde'] = date('Y-m-d h:i:s', $parsed['validFrom_time_t']);
						$result['vigencia_hasta'] = date('Y-m-d h:i:s', (int) $parsed['validTo_time_t']);
						$result['rfc'] = trim($rfc_cert[0]);
						$result['password'] = $password;
						$result['certificado'] = $certificado;
						$result['valid'] = TRUE;

						//-- Elimina temporales
						if (file_exists($keyFile))
							unlink($keyFile);
						if (file_exists($pemFile))
							unlink($pemFile);
					}
				}else {
					$result['valid'] = FALSE;
					$result['message'] = 'El RFC no corresponde al Certificado';
				}
			} else {
				$result['valid'] = FALSE;
				$result['message'] = 'La llave no corresponde al certificado.';
			}
		} else {
			$result['valid'] = FALSE;
			$result['message'] = 'La contraseña no corresponde al certificado';
		}
	} else {
		$result['valid'] = FALSE;
		$result['message'] = 'Certificado no valido.';
	}
	return $result;
}

function generarCadena($root) {
	$cadena = '||';

	//-- Datos del Comprobante
	$cadena .= $root->getAttribute('version');
	$cadena .= '|' . $root->getAttribute('fecha');
	$cadena .= '|' . $root->getAttribute('tipoDeComprobante');
	$cadena .= '|' . $root->getAttribute('formaDePago');
	$cadena .= '|' . $root->getAttribute('subTotal');
	
	if ($root->hasAttribute('descuento') && trim($root->getAttribute('descuento')) != '' && trim($root->getAttribute('descuento')) > 0) {
		$cadena .= '|' . $root->getAttribute('descuento');
	}
	
	if ($root->hasAttribute('condicionesDePago') && trim($root->getAttribute('condicionesDePago')) != '') {
		$cadena .= '|' . $root->getAttribute('condicionesDePago');
	}

	$cadena .= '|' . $root->getAttribute('total');
	$cadena .= '|' . $root->getAttribute('metodoDePago');
	$cadena .= '|' . $root->getAttribute('LugarExpedicion');
	if ($root->hasAttribute('NumCtaPago') && trim($root->getAttribute('NumCtaPago')) != '') {
		$cadena .= '|' . $root->getAttribute('NumCtaPago');
	}

	if ($root->hasAttribute('FolioFiscalOrig') && trim($root->getAttribute('FolioFiscalOrig')) != '') {
		$cadena .= '|' . $root->getAttribute('FolioFiscalOrig');
	}
	if ($root->hasAttribute('SerieFolioFiscalOrig') && trim($root->getAttribute('SerieFolioFiscalOrig')) != '') {
		$cadena .= '|' . $root->getAttribute('SerieFolioFiscalOrig');
	}
	if ($root->hasAttribute('FechaFolioFiscalOrig') && trim($root->getAttribute('FechaFolioFiscalOrig')) != '') {
		$cadena .= '|' . $root->getAttribute('FechaFolioFiscalOrig');
	}
	if ($root->hasAttribute('MontoFolioFiscalOrig') && trim($root->getAttribute('MontoFolioFiscalOrig')) != '') {
		$cadena .= '|' . $root->getAttribute('MontoFolioFiscalOrig');
	}

	//-- Datos del Emisor
	$emisor = $root->getElementsByTagName('Emisor')->item(0);
	$cadena .= '|' . $emisor->getAttribute('rfc');

	if ($emisor->hasAttribute('nombre') && trim($emisor->getAttribute('nombre')) != '') {
		$cadena .= '|' . $emisor->getAttribute('nombre');
	}
	//-- Domicilio Fiscal del Emisor
	//NODO OPCIONAL
	$domi = $emisor->getElementsByTagName('DomicilioFiscal')->item(0);
	if ($domi->hasAttribute('calle') && trim($domi->getAttribute('calle')) != '') {
		$cadena .= '|' . $domi->getAttribute('calle');
	}
	if ($domi->hasAttribute('noExterior') && trim($domi->getAttribute('noExterior')) != '') {
		$cadena .= '|' . $domi->getAttribute('noExterior');
	}
	if ($domi->hasAttribute('noInterior') && trim($domi->getAttribute('noInterior')) != '') {
		$cadena .= '|' . $domi->getAttribute('noInterior');
	}
	if ($domi->hasAttribute('colonia') && trim($domi->getAttribute('colonia')) != '') {
		$cadena .= '|' . $domi->getAttribute('colonia');
	}
	if ($domi->hasAttribute('localidad') && trim($domi->getAttribute('localidad')) != '') {
		$cadena .= '|' . $domi->getAttribute('localidad');
	}
	if ($domi->hasAttribute('referencia') && trim($domi->getAttribute('referencia')) != '') {
		$cadena .= '|' . $domi->getAttribute('referencia');
	}
	$cadena .= '|' . $domi->getAttribute('municipio');
	$cadena .= '|' . $domi->getAttribute('estado');
	$cadena .= '|' . $domi->getAttribute('pais');
	$cadena .= '|' . $domi->getAttribute('codigoPostal');


	//-- Domicilio de Expedici?n del Comprobante
	$domi = $emisor->getElementsByTagName('ExpedidoEn')->item(0);
	if ($domi->hasAttribute('calle') && trim($domi->getAttribute('calle')) != '') {
		$cadena .= '|' . $domi->getAttribute('calle');
	}
	if ($domi->hasAttribute('noExterior') && trim($domi->getAttribute('noExterior')) != '') {
		$cadena .= '|' . $domi->getAttribute('noExterior');
	}
	if ($domi->hasAttribute('noInterior') && trim($domi->getAttribute('noInterior')) != '') {
		$cadena .= '|' . $domi->getAttribute('noInterior');
	}
	if ($domi->hasAttribute('colonia') && trim($domi->getAttribute('colonia')) != '') {
		$cadena .= '|' . $domi->getAttribute('colonia');
	}
	if ($domi->hasAttribute('localidad') && trim($domi->getAttribute('localidad')) != '') {
		$cadena .= '|' . $domi->getAttribute('localidad');
	}
	if ($domi->hasAttribute('referencia') && trim($domi->getAttribute('referencia')) != '') {
		$cadena .= '|' . $domi->getAttribute('referencia');
	}
	if ($domi->hasAttribute('municipio') && trim($domi->getAttribute('municipio')) != '') {
		$cadena .= '|' . $domi->getAttribute('municipio');
	}
	if ($domi->hasAttribute('estado') && trim($domi->getAttribute('estado')) != '') {
		$cadena .= '|' . $domi->getAttribute('estado');
	}
	$cadena .= '|' . $domi->getAttribute('pais');
	if ($domi->hasAttribute('codigoPostal') && trim($domi->getAttribute('codigoPostal')) != '') {
		$cadena .= '|' . $domi->getAttribute('codigoPostal');
	}

	$regimen = $emisor->getElementsByTagName('RegimenFiscal')->item(0);
	$cadena .= '|' . $regimen->getAttribute('Regimen');

	//-- Datos del Receptor
	$receptor = $root->getElementsByTagName('Receptor')->item(0);
	$cadena .= '|' . $receptor->getAttribute('rfc');
	if ($receptor->hasAttribute('nombre') && trim($receptor->getAttribute('nombre')) != '') {
		$cadena .= '|' . $receptor->getAttribute('nombre');
	}

	//-- Domicilio Fiscal del Receptor
	if ($receptor->getElementsByTagName('Domicilio')->length > 0) {
		$domi = $receptor->getElementsByTagName('Domicilio')->item(0);
		if ($domi->hasAttribute('calle') && trim($domi->getAttribute('calle')) != '') {
			$cadena .= '|' . $domi->getAttribute('calle');
		}
		if ($domi->hasAttribute('noExterior') && trim($domi->getAttribute('noExterior')) != '') {
			$cadena .= '|' . $domi->getAttribute('noExterior');
		}
		if ($domi->hasAttribute('noInterior') && trim($domi->getAttribute('noInterior')) != '') {
			$cadena .= '|' . $domi->getAttribute('noInterior');
		}
		if ($domi->hasAttribute('colonia') && trim($domi->getAttribute('colonia')) != '') {
			$cadena .= '|' . $domi->getAttribute('colonia');
		}
		if ($domi->hasAttribute('localidad') && trim($domi->getAttribute('localidad')) != '') {
			$cadena .= '|' . $domi->getAttribute('localidad');
		}
		if ($domi->hasAttribute('referencia') && trim($domi->getAttribute('referencia')) != '') {
			$cadena .= '|' . $domi->getAttribute('referencia');
		}
		if ($domi->hasAttribute('municipio') && trim($domi->getAttribute('municipio')) != '') {
			$cadena .= '|' . $domi->getAttribute('municipio');
		}
		if ($domi->hasAttribute('estado') && trim($domi->getAttribute('estado')) != '') {
			$cadena .= '|' . $domi->getAttribute('estado');
		}
		$cadena .= '|' . $domi->getAttribute('pais');
		if ($domi->hasAttribute('codigoPostal') && trim($domi->getAttribute('codigoPostal')) != '') {
			$cadena .= '|' . $domi->getAttribute('codigoPostal');
		}
	}
	//-- Conceptos relacionados en el Comprobante
	$conceptos = $root->getElementsByTagName('Conceptos')->item(0)->getElementsByTagName('Concepto');

	for ($i = 0; $i < $conceptos->length; $i++) {
		$concepto = $conceptos->item($i);
		$cadena .= '|' . $concepto->getAttribute('cantidad');
		$cadena .= '|' . $concepto->getAttribute('unidad');

		if ($concepto->hasAttribute('noIdentificacion') && trim($concepto->getAttribute('noIdentificacion')) != '') {
			$cadena .= '|' . $concepto->getAttribute('noIdentificacion');
		}

		$cadena .= '|' . $concepto->getAttribute('descripcion');
		$cadena .= '|' . $concepto->getAttribute('valorUnitario');
		$cadena .= '|' . $concepto->getAttribute('importe');

		//-- Informacion Aduanal del concepto
		if ($concepto->getElementsByTagName('InformacionAduanera')->length > 0) {
			$aduana = $concepto->getElementsByTagName('InformacionAduanera')->item(0);
			$cadena .= '|' . $aduana->getAttribute('numero');
			$cadena .= '|' . $aduana->getAttribute('fecha');
			if ($aduana->hasAttribute('aduana') && trim($aduana->getAttribute('aduana')) != '') {
				$cadena .= '|' . $aduana->getAttribute('aduana');
			}
		}
	}

	//-- Informacion de Impuestos Retenidos y Trasladados
	if ($root->getElementsByTagName('Impuestos')->length > 0) {
		$impuestos = $root->getElementsByTagName('Impuestos')->item(0);
		
		//-- Retenciones
		if ($root->getElementsByTagName('Retenciones')->length > 0) {
			$imptos = $root->getElementsByTagName('Retencion');
			
			for ($i = 0; $i < $imptos->length; $i++) {
				$impto = $imptos->item($i);
				if ($impto->getAttribute('impuesto') && trim($impto->getAttribute('impuesto')) != '') {
					$cadena .= '|' . $impto->getAttribute('impuesto');
				}

				if (trim($impto->getAttribute('importe')) != '') {
					$cadena .= '|' . $impto->getAttribute('importe');
				}
			}
			
			
			if ($impuestos->hasAttribute('totalImpuestosRetenidos') && trim($impuestos->getAttribute('totalImpuestosRetenidos')) != '') {
				$cadena .= '|' . $impuestos->getAttribute('totalImpuestosRetenidos');
			}
			
		}
		
		//-- Traslados
		if ($root->getElementsByTagName('Traslados')->length > 0) {
			$imptos = $root->getElementsByTagName('Traslados')->item(0)->getElementsByTagName('Traslado');

			
			for ($i = 0; $i < $imptos->length; $i++) {
				$impto = $imptos->item($i);
				if ($impto->getAttribute('impuesto') && trim($impto->getAttribute('impuesto')) != '') {
					$cadena .= '|' . $impto->getAttribute('impuesto');
				}
				if ($impto->getAttribute('tasa') && trim($impto->getAttribute('tasa')) != '') {
					$cadena .= '|' . $impto->getAttribute('tasa');
				}
				if ($impto->getAttribute('importe') && trim($impto->getAttribute('importe')) != '') {
					$cadena .= '|' . $impto->getAttribute('importe');
				}
			}
			if ($impuestos->hasAttribute('totalImpuestosTrasladados') && trim($impuestos->getAttribute('totalImpuestosTrasladados')) != '') {
				$cadena .= '|' . $impuestos->getAttribute('totalImpuestosTrasladados');
			}
		}
	}

//	//COMPLEMENTO NOMINA
	if($root->getElementsByTagName('Nomina')->length > 0) {
		$complemento_nomina = $root->getElementsByTagName('Nomina')->item(0);
		
		$cadena .= '|' . $complemento_nomina->getAttribute('Version');
		
		
		if( $complemento_nomina->getAttribute('RegistroPatronal') && $complemento_nomina->getAttribute('RegistroPatronal') != '' ){
			$cadena .= '|' . $complemento_nomina->getAttribute('RegistroPatronal');
		}
		
		$cadena .= '|' . $complemento_nomina->getAttribute('NumEmpleado');
		
		$cadena .= '|' . $complemento_nomina->getAttribute('CURP');
		
		$cadena .= '|' . $complemento_nomina->getAttribute('TipoRegimen');
		
		$cadena .= '|' . $complemento_nomina->getAttribute('NumSeguridadSocial');
		
		$cadena .= '|' . $complemento_nomina->getAttribute('FechaPago');
		
		$cadena .= '|' . $complemento_nomina->getAttribute('FechaInicialPago');
		
		$cadena .= '|' . $complemento_nomina->getAttribute('FechaFinalPago');
		
		$cadena .= '|' . $complemento_nomina->getAttribute('NumDiasPagados');
		
		if( $complemento_nomina->getAttribute('Departamento') && $complemento_nomina->getAttribute('Departamento') != '' ){
			$cadena .= '|' . $complemento_nomina->getAttribute('Departamento');
		}
		
		if( $complemento_nomina->getAttribute('CLABE') && $complemento_nomina->getAttribute('CLABE') != '' ){
			$cadena .= '|' . $complemento_nomina->getAttribute('CLABE');
		}
		
		if( $complemento_nomina->getAttribute('Banco') && $complemento_nomina->getAttribute('Banco') != '' ){
			$cadena .= '|' . $complemento_nomina->getAttribute('Banco');
		}
		
		$cadena .= '|' . $complemento_nomina->getAttribute('FechaInicioRelLaboral');
		
//		if( $complemento_nomina->getAttribute('Antiguedad') && $complemento_nomina->getAttribute('Antiguedad') != '' ){
			$cadena .= '|' . $complemento_nomina->getAttribute('Antiguedad');
//		}
		
//		if( $complemento_nomina->getAttribute('Puesto') && $complemento_nomina->getAttribute('Puesto') != '' ){
			$cadena .= '|' . $complemento_nomina->getAttribute('Puesto');
//		}
		
//		if( $complemento_nomina->getAttribute('TipoContrato') && $complemento_nomina->getAttribute('TipoContrato') != '' ){
			$cadena .= '|' . $complemento_nomina->getAttribute('TipoContrato');
//		}
		
//		if( $complemento_nomina->getAttribute('TipoJornada') && $complemento_nomina->getAttribute('TipoJornada') != '' ){
			$cadena .= '|' . $complemento_nomina->getAttribute('TipoJornada');
//		}
		
//		if( $complemento_nomina->getAttribute('PeriodicidadPago') && $complemento_nomina->getAttribute('PeriodicidadPago') != '' ){
			$cadena .= '|' . $complemento_nomina->getAttribute('PeriodicidadPago');
//		}
		
//		<!--if( $complemento_nomina->getAttribute('SalarioBaseCotApor') && $complemento_nomina->getAttribute('SalarioBaseCotApor') != '' ){-->
			$cadena .= '|' . $complemento_nomina->getAttribute('SalarioBaseCotApor');
//		}
		
//		if( $complemento_nomina->getAttribute('RiesgoPuesto') && $complemento_nomina->getAttribute('RiesgoPuesto') != '' ){
			$cadena .= '|' . $complemento_nomina->getAttribute('RiesgoPuesto');
//		}
		
//		if( $complemento_nomina->getAttribute('SalarioDiarioIntegrado') && $complemento_nomina->getAttribute('SalarioDiarioIntegrado') != '' ){
			$cadena .= '|' . $complemento_nomina->getAttribute('SalarioDiarioIntegrado');
//		}
		
		
		
		
		//PERCEPCIONES
		if ($complemento_nomina->getElementsByTagName('Percepciones')->length > 0) {
			$percepciones = $complemento_nomina->getElementsByTagName('Percepciones')->item(0);
			
//			if( $percepciones->getAttribute('TotalGravado') && $percepciones->getAttribute('TotalGravado') != '' ){
				$cadena .= '|' . $percepciones->getAttribute('TotalGravado');
//			}

//			if( $percepciones->getAttribute('TotalExento') && $percepciones->getAttribute('TotalExento') != '' ){
				$cadena .= '|' . $percepciones->getAttribute('TotalExento');
//			}
			
			$percepcion = $complemento_nomina->getElementsByTagName('Percepcion');
			for ($i = 0; $i < $percepcion->length; $i++) {
				$atr_percepcion = $percepcion->item($i);
				
//				if ($atr_percepcion->getAttribute('TipoPercepcion') && trim($atr_percepcion->getAttribute('TipoPercepcion')) != '') {
					$cadena .= '|' . $atr_percepcion->getAttribute('TipoPercepcion');
//				}
//				if ($atr_percepcion->getAttribute('Clave') && trim($atr_percepcion->getAttribute('Clave')) != '') {
					$cadena .= '|' . $atr_percepcion->getAttribute('Clave');
//				}
//				if ($atr_percepcion->getAttribute('Concepto') && trim($atr_percepcion->getAttribute('Concepto')) != '') {
					$cadena .= '|' . $atr_percepcion->getAttribute('Concepto');
//				}
//				if ($atr_percepcion->getAttribute('ImporteGravado') && trim($atr_percepcion->getAttribute('ImporteGravado')) != '') {
					$cadena .= '|' . $atr_percepcion->getAttribute('ImporteGravado');
//				}
//				if ($atr_percepcion->getAttribute('ImporteExento') && trim($atr_percepcion->getAttribute('ImporteExento')) != '') {
					$cadena .= '|' . $atr_percepcion->getAttribute('ImporteExento');
//				}
			}
		}
		
		
		//DEDUCCIONES
		if ($complemento_nomina->getElementsByTagName('Deducciones')->length > 0) {
			$deducciones = $complemento_nomina->getElementsByTagName('Deducciones')->item(0);
			
//			if( $deducciones->getAttribute('TotalGravado') && $deducciones->getAttribute('TotalGravado') != '' ){
				$cadena .= '|' . $deducciones->getAttribute('TotalGravado');
//			}

//			if( $deducciones->getAttribute('TotalExento') && $deducciones->getAttribute('TotalExento') != '' ){
				$cadena .= '|' . $deducciones->getAttribute('TotalExento');
//			}
			
			$deduccion = $complemento_nomina->getElementsByTagName('Deduccion');
			for ($i = 0; $i < $deduccion->length; $i++) {
				$atr_deduccion = $deduccion->item($i);
				
//				if ($atr_deduccion->getAttribute('TipoDeduccion') && trim($atr_deduccion->getAttribute('TipoDeduccion')) != '') {
					$cadena .= '|' . $atr_deduccion->getAttribute('TipoDeduccion');
//				}
//				if ($atr_deduccion->getAttribute('Clave') && trim($atr_deduccion->getAttribute('Clave')) != '') {
					$cadena .= '|' . $atr_deduccion->getAttribute('Clave');
//				}
//				if ($atr_deduccion->getAttribute('Concepto') && trim($atr_deduccion->getAttribute('Concepto')) != '') {
					$cadena .= '|' . $atr_deduccion->getAttribute('Concepto');
//				}
//				if ($atr_deduccion->getAttribute('ImporteGravado') && trim($atr_deduccion->getAttribute('ImporteGravado')) != '') {
					$cadena .= '|' . $atr_deduccion->getAttribute('ImporteGravado');
//				}
//				if ($atr_deduccion->getAttribute('ImporteExento') && trim($atr_deduccion->getAttribute('ImporteExento')) != '') {
					$cadena .= '|' . $atr_deduccion->getAttribute('ImporteExento');
//				}
			}
		}
		
	}
	//IMPUESTOS LOCALES
	if ($root->getElementsByTagName('ImpuestosLocales')->length > 0) {
		
		$complemento_implocal = $root->getElementsByTagName('ImpuestosLocales')->item(0);
		
		$cadena .= '|' . $complemento_implocal->getAttribute('version');

		$cadena .= '|' . $complemento_implocal->getAttribute('TotaldeRetenciones');

		$cadena .= '|' . $complemento_implocal->getAttribute('TotaldeTraslados');

		if ($complemento_implocal->getElementsByTagName('RetencionesLocales')->length > 0) {
			$retlocales = $complemento_implocal->getElementsByTagName('RetencionesLocales')->item(0);
			$cadena .= '|' . $retlocales->getAttribute('ImpLocRetenido');
			$cadena .= '|' . $retlocales->getAttribute('TasadeRetencion');
			$cadena .= '|' . $retlocales->getAttribute('Importe');
		}
		if ($complemento_implocal->getElementsByTagName('TrasladosLocales')->length > 0) {
			$retlocales = $complemento_implocal->getElementsByTagName('TrasladosLocales')->item(0);
			$cadena .= '|' . $retlocales->getAttribute('ImpLocTrasladado');
			$cadena .= '|' . $retlocales->getAttribute('TasadeTraslado');
			$cadena .= '|' . $retlocales->getAttribute('Importe');
		}
	}
	
	//-- Cierre de cadena
	$cadena .= '||';
	//-- Limpieza de WhiteSpaces y trimming de pipes (|)
	$cadena = preg_replace('/\| | \|/', '|', preg_replace('/\s+/', ' ', $cadena));

//	//-- Codificamos la cadena como UTF-8
//	$cadena = utf8_encode($cadena);
	//file_put_contents('cadena_' + rand(10000,99999) . '.txt', $cadena);
	return ($cadena);
}
