<?php
  
include_once('interface.IConectorServisim.php');
class ConectorServisim implements IConectorServisim {
      
    public function __construct(){
        $this->wsdl = null;
        $this->user = null;
        $this->pass = null;
        $this->nameSpace = null;
        $this->method = null;
    }
      
    public function establecerEndPoint($endPoint){
        $this->wsdl = $endPoint.'?wsdl';
    }
      
    public function establecerSoapAction($nameSpace, $method){
        $this->nameSpace = $nameSpace;
        $this->method = $method;
    }
      
    public function establecerAcceso($user, $pass){
        $this->user = $user;
        $this->pass = $pass;
    }
      
    public function crearPeticion(){
        $this->request = new StdClass();
    }
      
    public function asignarEnPeticion($name, $value){
        switch($this->nameSpace){
            case 'http://controller.timbrado.ws.servisim.com/':
                switch($name){
                    case 'Id':
                        $this->request->id = $value;
                        break;
                    case 'Xml':
                        $this->request->xml = new SoapVar('<xml><![CDATA['.$value.']]></xml>', XSD_ANYXML);
                        break;
                    default:
                        throw new Exception('Propiedad inválida: '.$name);
                }
                break;
            case 'http://controller.distribuidor.ws.servisim.com/':
                switch($name){
                    case 'Certificado':
                        $this->request->certificado = $value;
                        break;
                    case 'Llave':
                        $this->request->llave = $value;
                        break;
                    case 'Password':
                        $this->request->password = $value;
                        break;
                    case 'Rfc':
                        $this->request->rfc = $value;
                        break;
                    case 'Token':
                        $this->request->token = $value;
                        break;
                    default:
                        throw new Exception('Propiedad inválida: '.$name);
                }
                break;
            default:
                throw new Exception('NameSpace inválido: '.$this->nameSpace);
        }
    }
      
    public function consumirServicio(){
        try{        
            $cliente = new SoapClient($this->wsdl);
            $header = UtilServisim::obtenerCabeceraSOAP($this->user, $this->pass);
            $cliente->__setSoapHeaders(array($header));
            $result = null;
            switch($this->nameSpace){
                case 'http://controller.timbrado.ws.servisim.com/':
                    switch($this->method){
                        case 'timbrarCFDi':
                            $result = $cliente->timbrarCFDi(array('RequestServisim'=>$this->request));
                            break;
                        case 'obtenerCFDi':
                            $result = $cliente->obtenerCFDi(array('RequestServisim'=>$this->request));
                            break;
                        case 'cancelarCFDi':
                            $result = $cliente->cancelarCFDi(array('RequestServisim'=>$this->request));
                            break;
                        default:
                            throw new Exception('SoapAction inválida: '.$this->method);
                    }
                    $this->response = $result->ResponseServisim;
                    break;
                case 'http://controller.distribuidor.ws.servisim.com/':
                    switch($this->method){
                        case 'registrarEmisor':
                            $result = $cliente->registrarEmisor(array('RequestAdmin'=>$this->request));
                            break;
                        default:
                            throw new Exception('SoapAction inválida: '.$this->method);
                    }
                    $this->response = $result->ResponseAdmin;
                    break;
                default:
                    throw new Exception('NameSpace inválido: '.$this->nameSpace);
            }           
            $this->request = null;
        }
        catch (Exception $ex) {
            throw new Exception('Error al conectar con servicio web. '.$ex->getMessage());
        }
    }
      
    public function obtenerDeRespuesta($name){
        switch($this->nameSpace){
            case 'http://controller.timbrado.ws.servisim.com/':
                switch($name){
                    case 'IdError':
                        return $this->response->idError;
                    case 'Error':
                        return $this->response->error;
                    case 'Uuid':
                        return $this->response->uuid;
                    case 'FechaTimbre':
                        return $this->response->fechaTimbre;
                    case 'Xml':
                        return $this->response->xml;
                    default:
                        throw new Exception('Propiedad inválida: '.$name);
                }
                break;
            case 'http://controller.distribuidor.ws.servisim.com/':
                switch($name){
                    case 'IdError':
                        return $this->response->idError;
                    case 'Resultado':
                        return $this->response->resultado;
                    default:
                        throw new Exception('Propiedad inválida: '.$name);
                }
                break;
            default:
                throw new Exception('NameSpace inválido: '.$this->nameSpace);
        }
    }
}
  
?>